#!/usr/bin/ruby
# @Author: dingxizheng
# @Date:   2016-01-21 15:38:08
# @Last Modified by:   mover
# @Last Modified time: 2016-01-22 14:34:16

require File.expand_path(File.dirname(__FILE__) + '/spec_helper')

describe Mongoid::Liker do

	before(:each) do 
		@user = User.create({
				:name => "ding"
			})
	end

	before(:each) do 
		@posts = []
		@posts << Post.create({ :title => "post 1" })
		@posts << Post.create({ :title => "post 2" })
		@posts << Post.create({ :title => "post 3" })
	end

	it "should return 0 likes" do 
		expect(@user.likes).to eq 0
	end

	it "should return 1 likes" do 
		@user.like(@posts[0])
		expect(@posts[0].likes).to eq 1
	end

	it "should return 1 likes" do 
		@user.like(@posts[1])
		expect(@posts[1].likes).to eq 1
	end

	it "should return the liked post1" do 
		@user.like(@posts[1])
		expect(@posts[1].likers.first).to eq @user
	end

	it "should return the numember of likes" do 
		@user.like(@posts[1])
		@user.unlike(@posts[1])
		expect(@posts[1].likes).to eq 0
	end

	it "should return the numember of likes" do 
		@user.like(@posts[1])
		@user.unlike(@posts[1])
		expect(@posts[1].likes).to eq 0
	end

	it "should return true" do 
		@user.like(@posts[2])
		expect(@posts[2].liked_by? @user).to eq true
		expect(@user.liked? @posts[2]).to eq true
	end

	it "should return true when post1 is disliked by user" do 
		@user.dislike(@posts[1])
		@user.like(@posts[1])
		expect(@posts[1].liked_by? @user).to eq false
		expect(@user.disliked? @posts[1]).to eq true
	end

	it "should return a list of disliked posts" do 
		@user.dislike(@posts[0])
		@user.dislike(@posts[1])
		expect(@user.all_disliked('post').count).to eq 2
	end

	it "should return a list of liked posts" do 
		@user.like(@posts[0])
		@user.like(@posts[1])
		@user.dislike(@posts[1])
		expect(@user.all_liked('post').count).to eq 2
	end
	
end