#!/usr/bin/ruby
# @Author: dingxizheng
# @Date:   2016-01-21 14:33:10
# @Last Modified by:   mover
# @Last Modified time: 2016-01-22 14:10:09

require 'mongoid'
require 'database_cleaner'

Dir["#{File.dirname(__FILE__)}/../lib/**/*.rb"].each { |file|
	require file 
}

Mongo::Logger.logger.level = ::Logger::FATAL
Mongoid.configure do |config|
  config.connect_to "mongoid_likes_test"
  config.options = { :raise_not_found_error => false }
end

Dir["#{File.dirname(__FILE__)}/models/*.rb"].each { |file|
	require file 
}

DatabaseCleaner.orm = :mongoid

RSpec.configure do |config|

  config.before(:all) do
    DatabaseCleaner.strategy = :truncation
  end

  config.before(:each) do
    DatabaseCleaner.start
  end

  config.after(:each) do
    DatabaseCleaner.clean
  end

end